gui/config/routes.rb
Smr::Application.routes.draw do

  root :to => 'asset#index'

  resources :asset
  get  '/asset/show_portfolio/:id_portfolio', :to=>'asset#index', :as=>'show_portfolio'
  post '/asset/show_portfolio/',              :to=>'asset#index', :as=>'show_portfolio_post'

  resources :order
  resources :report
  resources :cashflow
  resources :watchlist
  resources :figures
  resources :quoterecords
  resources :quoterecord_threshold
  resources :quoterecord_rules

  post "set_session_params" => "application#set_session_params"

  get 'logout' => 'sessions#destroy', :as => 'logout'
  get 'login' => 'sessions#new', :as => 'login'
  resources :sessions
  resources :password_reset

  resources :position
  post 'execute_order', to: 'position#execute_order'
  post 'cancel_order', to: 'position#cancel_order'
  post 'patch_position', to: 'position#patch'
  get 'close', to: 'position#close'

  get '/workdesk/add',      :to=>'workdesk#add',  :as=>'workdesk_add'
  get '/workdesk/:id/drop', :to=>'workdesk#drop', :as=>'workdesk_drop'
  resources :workdesk

  resources :portrait
  get '/portrait/organization/:id', :to=>'portrait#show_organization', :as=>'portrait_organization'
  get '/portrait/security/:id',     :to=>'portrait#show_security',     :as=>'portrait_security'

  resources :cashposition
  get '/cashposition/:id/settle', :to=>'cashposition#settle', :as=>'settle_cashposition'

  resources :documents
  get 'download' => 'documents#download'
  get 'delete_document' => 'documents#delete_document'

  resources :blog
  get 'blog' => 'blog#index'

  get 'objects' => 'objects#index'
  namespace 'objects' do
      resources :organization, :security, :bookmark, :portfolio, :figurevar, :user
      post 'patch_portfolio', to: 'portfolio#patch'
  end
  get '/objects/security/:id/delete', :to=>'objects/security#destroy', :as=>'delete_security'
  get '/objects/export/securities',   :to=>'objects/security#export',  :as=>'export_securities'
  get '/objects/bookmark/:id/delete', :to=>'objects/bookmark#destroy', :as=>'delete_bookmark'

  resources :doc, :only=>:get_file
  get "/doc/:file_or_folder", :controller=>:documentation, :action=>:get_file, :file_or_folder=>/.*/
end

gui/app/controllers/watchlist_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#
require 'watchlist'

##
# Shows Securities not held in Assets, permits to filter them.
class WatchlistController < ApplicationController

    ##
    # Generates lists of Securities to watch by utilizing Smr::Watchlist.
    #
    # Naturally each security that is not held in a open position is on the
    # watchlist. There is no reason for the user to add/remove items. There is
    # only one global watchlist in SMR.
    #
    # It provides means to filter, sort and comment the listed items.
    def index
        smr_menu_addsubitem('watchlist', {
            '+ quote'=>:new_watchlist,
        })
        session[:watchlist_query] = params[:q] if params[:q]

        session[:watchlist_exclude_securities] = (params[:exclude_securities] ? params[:exclude_securities] : false)
        @opt_exclude_securities = session[:watchlist_exclude_securities]

        session[:watchlist_provides_collateral] = (params[:provides_collateral] ? params[:provides_collateral] : false)
        @opt_provides_collateral = session[:watchlist_provides_collateral]

        session[:watchlist_provides_cashflow] = (params[:provides_cashflow] ? params[:provides_cashflow] : false)
        @opt_provides_cashflow = session[:watchlist_provides_cashflow]

        session[:watchlist_provides_huge_coupon] = (params[:provides_huge_coupon] ? params[:provides_huge_coupon] : false)
        @opt_provides_huge_coupon = session[:watchlist_provides_huge_coupon]

        session[:watchlist_provides_subannual_payments] = (params[:provides_subannual_payments] ? params[:provides_subannual_payments] : false)
        @opt_provides_subannual_payments = session[:watchlist_provides_subannual_payments]

        session[:watchlist_matures_within_year] = (params[:matures_within_year] ? params[:matures_within_year] : false)
        @opt_matures_within_year = session[:watchlist_matures_within_year]

        @watchlist = Smr::Watchlist.new(
            current_user,
            smr_browse_date,
            :ransack_query=>session[:watchlist_query],
            :exclude_securities=>(session[:watchlist_exclude_securities] ? smr_securities_in_open_positions_list : false),
            :provides_collateral=>@opt_provides_collateral,
            :provides_cashflow=>@opt_provides_cashflow,
            :provides_huge_coupon=>@opt_provides_huge_coupon,
            :provides_subannual_payments=>@opt_provides_subannual_payments,
            :matures_within_year=>@opt_matures_within_year,
        )
        @securities = smr_securities_list

        if params[:intraday_data] then
            @have_intraday_data = params[:intraday_data].to_i
            @intraday_data = Quote.where(:id_security=>params[:intraday_data].to_i)
                             .where(:date=>smr_browse_date.beginning_of_day.to_i..smr_browse_date.to_i)
                             .order(date: :desc)
        end
    end

    ##
    # handle new/updated Quote
    def new
        self.index
        if params[:id] then
            @quote = Quote.where(:id=>params[:id]).first
        else @quote = Quote.new(:date_last=>Time.now.to_i) end

        render :index
    end

    ##
    # handles creates and updates for Quote
    def create
        if params[:quote][:id].to_i > 0 then
            q = Quote.where(:id=>params[:quote][:id]).first
        else q = Quote.new(quote_params) end

        q.date_last = Time.parse(params[:time]).to_i if params[:time]
        q.exchange = 'Quotation by SMR User' if q.exchange.empty?

        if params[:quote][:id].to_i > 0 then
            q.update(quote_params)
        else q.save end

        # FIXME: bug in rails?
        # - this :notice flash message it lost when using redirect_to
        # - it is not lost if the default template is rendered: app/views/asset/create.html.erb
        #redirect_to assets_path, :notice=>q.errors.full_messages.uniq.join(', ')
        flash.notice = 'Adding Quote failed: ' + q.errors.full_messages.uniq.join(', ') if not q.errors.empty?

        if URI(request.referer).path == new_asset_path then
            index
            render :index
        else redirect_to :back end
    end
end

gui/app/views/watchlist/index.html.erb
<h1>Watchlist</h1>

<% if @quote %>
    <%= render :partial=>'asset/quote_form', locals: { :quote=>@quote, :securities=>@securities  } %>
<% end %>

<%= search_form_for @watchlist.query, :url=>{:controller=>:watchlist, :action=>:index}, :class=>'filter_form, watchlist_filter', :id=>:controller_filter do |f| %>
<div>
    <%= f.search_field :symbol_or_brief_or_Organization_name_cont_any, :placeholder=>'Pattern' %>
    <%= f.submit :filter %>

 <table>
    <tr><th colspan="2">Generic Filters</th></tr>
    <tr><td><%= check_box_tag :exclude_securities, true, @opt_exclude_securities %></td><td><%= f.label :exclude_held_securities %></td></tr>

    <tr><td><%= check_box_tag :provides_collateral, true, @opt_provides_collateral %></td><td><%= f.label :provides_collateral %></td></tr>

    <tr><td><%= check_box_tag :provides_cashflow, true, @opt_provides_cashflow %></td><td><%= f.label :provides_cashflow_this_year %></td></tr>

    <tr><td><%= check_box_tag :provides_huge_coupon, true, @opt_provides_huge_coupon %></td><td><%= f.label :provides_huge_coupon %></td></tr>

    <tr><td><%= check_box_tag :provides_subannual_payments, true, @opt_provides_subannual_payments %></td><td><%= f.label :provides_subannual_payments %></td></tr>

    <tr><td><%= check_box_tag :matures_within_year, true, @opt_matures_within_year %></td><td><%= f.label :matures_within_year %></td></tr>

    <tr><th colspan="2">Type of Security</th></tr>
    <% Security.types.each do |t|
       type_id_column = ('id_security_%s_gt' % t).to_sym
       %>
       <tr><td><%= check_box_tag 'q[%s]' % type_id_column,
              0,
              (if params[:q] and params[:q][type_id_column] then true else false end)
       %></td><td>
       <%= label_tag 'q[%s][]' % type_id_column, Security.describe_type(t) %></td></tr>
    <% end %>

    <tr><th colspan="2">Bond Properties</th></tr>
    <% SecurityBond.types.each do |t| %>
       <tr><td><%= check_box_tag 'q[SecurityBond_type_eq_any][]',
              t.second,
              (if params[:q] and params[:q][:SecurityBond_type_eq_any] and params[:q][:SecurityBond_type_eq_any].include?(t.second.to_s) then true else false end)
       %></td><td>
       <%= label_tag 'q[SecurityBond_type_eq_any][]', SecurityBond.describe_type(t.first) %></td></tr>
    <% end %>

    <tr><th colspan="2">Stock Properties</th></tr>
    <% SecurityStock.types.each do |t| %>
       <tr><td><%= check_box_tag 'q[SecurityStock_type_eq_any][]',
              t.second,
              (if params[:q] and params[:q][:SecurityStock_type_eq_any] and params[:q][:SecurityStock_type_eq_any].include?(t.second.to_s) then true else false end)
       %></td><td>
       <%= label_tag 'q[SecurityStock_type_eq_any][]', SecurityStock.describe_type(t.first) %></td></tr>
    <% end %>
 </table>
</div>
<% end %>

<div id='watchlist_overview' class="overview_counters">
  <ul>
    <li>Items Found: <span><%= @watchlist.count %></span></li>
  </ul>
</div>

<table id='watchlist'>
  <thead>
    <tr>
    </tr>
    <tr>
        <th></th>
        <th>Exchange</th>
        <th>Low / High</th>
        <th>Volume</th>
        <th>Last Trade</th>
        <th><%= sort_link @watchlist.query, :current_yield, 'CY', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :yield_to_maturity, 'YTM', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :yield_to_call, 'YTC', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :cashflow_this_year, 'Cashflow this Year', default_order: :desc %></th>
        <th><%= sort_link @watchlist.query, :collateral_coverage_ratio, 'Collateral Provided', default_order: :desc %></th>
    </tr>
  </thead>
  <tbody>
  <% @watchlist.each do |i| %>
    <tr class="separaterows">
      <td>
        <%= link_to '+', watchlist_index_path(:intraday_data=>i.id, :anchor=>"watchlist_id#{i.id}"), :id=>"watchlist_id#{i.id}" %>
        <%= link_to '...', i.security.link.to_url %>
        <%= i.security %>
        <span class="symbol"><%=i.security.symbol%></span>
      </td>
      <td><%= i.quote.exchange %></td>
          <td>
            <% if i.quote.low or i.quote.high %>
                <%= smr_humanize(i.quote.low) %> / <%= smr_humanize(i.quote.high) %>
            <% end %>
          </td>
      <td><%= smr_humanize(i.quote.volume, :shortword=>true)%></td>
      <td><%= smr_humanize i.quote.last %> <span class="<%= i.quote.css_class(smr_browse_date(:keep_current_time=>true), :intraday=>true) %>">&bull;</span></td>
      <td><%= smr_humanize(i.security.current_yield(i.quote), :scale=>2)%></td>
      <td><%= smr_humanize(i.security.yield_to_maturity(i.quote), :scale=>2)%></td>
      <td><%= smr_humanize(i.security.yield_to_call(i.quote), :scale=>2)%></td>
      <td><%= smr_humanize(i.security.cashflow_this_year smr_browse_date)%></td>
      <td><%= smr_humanize i.security.collateral_coverage_ratio %></td>
    </tr>
   <% if @have_intraday_data == i.id %>
     <%
      _have_shown_cashflow = false
      @intraday_data.each do |q| %>
       <tr class="have_intraday_data">
          <td><%= smr_humanize(q.time, :date_time_only=>true) %></td>
          <td><%= q.exchange %></td>
          <td>
            <% if q.low or q.high %>
                <%= smr_humanize(q.low) %> / <%= smr_humanize(q.high) %>
            <% end %>
          </td>
          <td><%= smr_humanize q.volume, :shortword=>true %></td>
          <td><%= smr_humanize q.last %>&nbsp;&nbsp;</td>
          <td><%= smr_humanize i.security.current_yield(q), :scale=>2 %></td>
          <td><%= smr_humanize i.security.yield_to_maturity(q),:scale=>2 %></td>
        <% unless _have_shown_cashflow %>
          <td rowspan="<%= @intraday_data.count  %>">
            <div class="overview_container">
            <table id="overview_cashflow">
             <tbody>
              <% i.security.cashflow(:start_date=>smr_browse_date).each  do |c| %>
                <tr>
                    <td><%= smr_humanize c.date %></td>
                    <td><%= smr_humanize c.total, :scale=>2 %>
                       <% unless [0, 1.0].include? c.poolfactor %><span>pf=<%= smr_humanize c.poolfactor, :scale=>3 %></span><% end %>
                    </td>
                </tr>
              <% _have_shown_cashflow = true
               end %>
             </tbody>
            </table>
            </div>
          </td>
        <% end %>
       </tr>
     <% end %>
   <% end %>
  <% end %>
  </tbody>
</table>